/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package analog;

import javax.swing.JButton;
import w1.PowerMeter;
import w1.W1;

/**
 *
 * @author mm
 */
public class AnalogPanel extends javax.swing.JPanel implements PowerMeter {

    private boolean ledsOn, pep;
    private char decaySpeed;
    private W1 w1;

    /**
     * Creates new form AnalogPanel
     */
    public AnalogPanel() {
        this(null);
    }

    public AnalogPanel(W1 w1model) {
        initComponents();
        this.w1 = w1model;
        swrMeter.startFrameTimer();
    }

    public void setW1(W1 w1) {
        this.w1 = w1;
    }

    public double vswr(double fwd_W, double refl_W) {

        double gamma = Math.sqrt(refl_W / fwd_W);
        return (1 + gamma) / (1 - gamma);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        swrMeter = new analog.SwrMeter();
        buttonPanel = new javax.swing.JPanel();
        ledButton = new javax.swing.JButton();
        peakButton = new javax.swing.JButton();
        quitButton = new javax.swing.JButton();
        powerButton = new javax.swing.JButton();
        recallButton = new javax.swing.JButton();
        decayButton = new javax.swing.JButton();
        storeButton = new javax.swing.JButton();
        rangeButton = new javax.swing.JButton();
        needlesButton = new javax.swing.JButton();
        needlesLabel = new javax.swing.JLabel();
        rangeLabel = new javax.swing.JLabel();
        powerLabel = new javax.swing.JLabel();
        decayLabel = new javax.swing.JLabel();
        peakLabel = new javax.swing.JLabel();
        ledLabel = new javax.swing.JLabel();

        setBackground(new java.awt.Color(255, 255, 255));

        swrMeter.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(0, 0, 0)));
        swrMeter.setNextFocusableComponent(needlesButton);

        javax.swing.GroupLayout swrMeterLayout = new javax.swing.GroupLayout(swrMeter);
        swrMeter.setLayout(swrMeterLayout);
        swrMeterLayout.setHorizontalGroup(
            swrMeterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 766, Short.MAX_VALUE)
        );
        swrMeterLayout.setVerticalGroup(
            swrMeterLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 476, Short.MAX_VALUE)
        );

        buttonPanel.setBackground(new java.awt.Color(255, 255, 255));
        buttonPanel.setFocusable(false);
        buttonPanel.setNextFocusableComponent(swrMeter);
        buttonPanel.setRequestFocusEnabled(false);

        ledButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        ledButton.setText("LEDs");
        ledButton.setDefaultCapable(false);
        ledButton.setNextFocusableComponent(quitButton);
        ledButton.setRequestFocusEnabled(false);
        ledButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        peakButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        peakButton.setText("Peak");
        peakButton.setDefaultCapable(false);
        peakButton.setNextFocusableComponent(decayButton);
        peakButton.setRequestFocusEnabled(false);
        peakButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        quitButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        quitButton.setText("Quit");
        quitButton.setDefaultCapable(false);
        quitButton.setNextFocusableComponent(swrMeter);
        quitButton.setRequestFocusEnabled(false);
        quitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        powerButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        powerButton.setText("Power");
        powerButton.setDefaultCapable(false);
        powerButton.setNextFocusableComponent(peakButton);
        powerButton.setRequestFocusEnabled(false);
        powerButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        recallButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        recallButton.setText("Recall");
        recallButton.setDefaultCapable(false);
        recallButton.setNextFocusableComponent(storeButton);
        recallButton.setRequestFocusEnabled(false);
        recallButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        decayButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        decayButton.setText("Decay");
        decayButton.setDefaultCapable(false);
        decayButton.setNextFocusableComponent(ledButton);
        decayButton.setRequestFocusEnabled(false);
        decayButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        storeButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        storeButton.setText("Store");
        storeButton.setDefaultCapable(false);
        storeButton.setNextFocusableComponent(powerButton);
        storeButton.setRequestFocusEnabled(false);
        storeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        rangeButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        rangeButton.setText("Range");
        rangeButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        needlesButton.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        needlesButton.setText("Needles");
        needlesButton.setDefaultCapable(false);
        needlesButton.setNextFocusableComponent(recallButton);
        needlesButton.setRequestFocusEnabled(false);
        needlesButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                buttonHandler(evt);
            }
        });

        needlesLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        needlesLabel.setText("plain");

        rangeLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        rangeLabel.setText("auto");

        powerLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        powerLabel.setText("jLabel1");

        decayLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        decayLabel.setText("jLabel1");

        peakLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        peakLabel.setText("jLabel1");

        ledLabel.setFont(new java.awt.Font("DejaVu Sans", 0, 12)); // NOI18N
        ledLabel.setText("jLabel1");

        javax.swing.GroupLayout buttonPanelLayout = new javax.swing.GroupLayout(buttonPanel);
        buttonPanel.setLayout(buttonPanelLayout);
        buttonPanelLayout.setHorizontalGroup(
            buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(buttonPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(needlesLabel)
                    .addComponent(needlesButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(rangeLabel)
                    .addComponent(rangeButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(recallButton)
                .addGap(8, 8, 8)
                .addComponent(storeButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(powerLabel)
                    .addComponent(powerButton))
                .addGap(6, 6, 6)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(peakLabel)
                    .addComponent(peakButton))
                .addGap(6, 6, 6)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(decayLabel)
                    .addComponent(decayButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.CENTER)
                    .addComponent(ledLabel)
                    .addComponent(ledButton))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(quitButton)
                .addContainerGap())
        );

        buttonPanelLayout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {decayButton, ledButton, needlesButton, peakButton, powerButton, quitButton, recallButton, storeButton});

        buttonPanelLayout.setVerticalGroup(
            buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, buttonPanelLayout.createSequentialGroup()
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(needlesLabel)
                    .addComponent(rangeLabel)
                    .addComponent(powerLabel)
                    .addComponent(decayLabel)
                    .addComponent(peakLabel)
                    .addComponent(ledLabel))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(buttonPanelLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(recallButton)
                    .addComponent(storeButton)
                    .addComponent(powerButton)
                    .addComponent(peakButton)
                    .addComponent(decayButton)
                    .addComponent(ledButton)
                    .addComponent(quitButton)
                    .addComponent(rangeButton)
                    .addComponent(needlesButton))
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addGap(0, 0, Short.MAX_VALUE)
                .addComponent(swrMeter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(buttonPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(swrMeter, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(buttonPanel, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
    }// </editor-fold>//GEN-END:initComponents

    private void buttonHandler(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_buttonHandler
        JButton b = (JButton) evt.getSource();
        if (b == decayButton) {
            switch (decaySpeed) {
                case 'S': // Slow now, choose Medium
                    w1.w1cmd("5");
                    break;
                case 'M': // Medium now, choose Fast
                    w1.w1cmd("6");
                    break;
                case 'F': // Fast now, choose Slow
                    w1.w1cmd("4");
                    break;
                default: // Choose Medium by default
                    w1.w1cmd("5");
                    break;
            }
            setDecayRate(decaySpeed);
        } else if (b == ledButton) {
            w1.w1cmd("L");
        } else if (b == needlesButton) {
            if (swrMeter.isDigitalMode()) {
                needlesLabel.setText("plain");
                swrMeter.setDigitalMode(false);
            } else {
                needlesLabel.setText("lollipops");
                swrMeter.setDigitalMode(true);
            }
        } else if (b == peakButton) {
            w1.w1cmd("P");
        } else if (b == powerButton) {
            w1.w1cmd("N");
        } else if (b == rangeButton) {
            String s = rangeLabel.getText().trim();
            String cmd;
            if (s.equalsIgnoreCase("auto")) {
                cmd = "1";
            } else if (s.equalsIgnoreCase("1.4 W")) {
                cmd = "2";
            } else if (s.equalsIgnoreCase("14 W")) {
                cmd = "3";
            } else {
                cmd = "0";
            }
            w1.w1cmd(cmd);
            setRange(cmd.charAt(0));
        } else if (b == recallButton) {
            w1.w1cmd("U");
        } else if (b == storeButton) {
            w1.w1cmd("W");
        } else if (b == quitButton) {
            swrMeter.stopFrameTimer();
//            dispose();
            System.exit(0);
        }
    }//GEN-LAST:event_buttonHandler
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JPanel buttonPanel;
    private javax.swing.JButton decayButton;
    private javax.swing.JLabel decayLabel;
    private javax.swing.JButton ledButton;
    private javax.swing.JLabel ledLabel;
    private javax.swing.JButton needlesButton;
    private javax.swing.JLabel needlesLabel;
    private javax.swing.JButton peakButton;
    private javax.swing.JLabel peakLabel;
    private javax.swing.JButton powerButton;
    private javax.swing.JLabel powerLabel;
    private javax.swing.JButton quitButton;
    private javax.swing.JButton rangeButton;
    private javax.swing.JLabel rangeLabel;
    private javax.swing.JButton recallButton;
    private javax.swing.JButton storeButton;
    private analog.SwrMeter swrMeter;
    // End of variables declaration//GEN-END:variables

    @Override
    public void setDecayRate(char decayRate) {
        decaySpeed = decayRate;
        String s;
        switch (decayRate) {
            case 'S':
                s = "slow";
                break;
            case 'M':
                s = "medium";
                break;
            case 'F':
                s = "fast";
                break;
            default:
                s = "???";
                break;
        }
        decayLabel.setText(s);
        swrMeter.setDecayRate(decayRate);
    }

    @Override
    public void setFirmwareVersion(String fw) {
        swrMeter.setFirmwareVersion(fw);
    }

    @Override
    public void setFwd_W(double fwd_W) {
        swrMeter.setFwd_W(fwd_W);
    }

    @Override
    public boolean isPeakHold() {
        return swrMeter.isPeakHold();
    }

    @Override
    public void setPeakHold(boolean hold) {
        peakLabel.setText(hold ? "hold" : "peak");
        swrMeter.setPeakHold(hold);
    }

    @Override
    public void setRfl_W(double rfl_W) {
        swrMeter.setRfl_W(rfl_W);
    }

    @Override
    public boolean isMonochrome() {
        return swrMeter.isMonochrome();
    }

    @Override
    public void setMonochrome(boolean monochrome) {
        swrMeter.setMonochrome(monochrome);
        swrMeter.recreateMeterImage();
    }

    @Override
    public boolean isLedsOn() {
        return ledsOn;
    }

    @Override
    public void setLedsOn(boolean ledsOn) {
        this.ledsOn = ledsOn;
        ledLabel.setText(ledsOn ? "on" : "off");
    }

    @Override
    public boolean isPEP() {
        return pep;
    }

    @Override
    public void setPEP(boolean pep) {
        powerLabel.setText(pep ? "avg" : "pep");
        swrMeter.setPEP(pep);
    }

    @Override
    public void startFrameTimer() {
        swrMeter.startFrameTimer();
    }

    @Override
    public void stopFrameTimer() {
        swrMeter.stopFrameTimer();
    }

    @Override
    public void setDropRate(char dropRate) {
    }

    @Override
    public void setRange(char range) {
        String s;
        switch (range) {
            case '0':
                s = "auto";
                break;
            case '1':
                s = "1.4 W";
                break;
            case '2':
                s = "14 W";
                break;
            case '3':
                s = "140 W";
                break;
            default:
                s = "???";
                break;
        }
        rangeLabel.setText(s);
        swrMeter.setRange(range);
    }

    @Override
    public boolean isUnits_W() {
        throw new UnsupportedOperationException("Not supported yet.");
    }

    @Override
    public void setUnits_W(boolean units_W) {
        throw new UnsupportedOperationException("Not supported yet.");
    }
}
